.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

;#########################################################################

include windows.inc
include kernel32.inc
include user32.inc
include comctl32.inc

includelib kernel32.lib
includelib user32.lib
includelib comctl32.lib

WndProc			PROTO	:HWND,:UINT,:WPARAM,:LPARAM
TEA_encode		PROTO	:DWORD,:DWORD

	; ---------------------
    ; literal string MACRO
    ; ---------------------
      literal MACRO quoted_text:VARARG
        LOCAL local_text
        .data
          local_text db quoted_text,0
        .code
        EXITM <local_text>
      ENDM
    ; --------------------------------
    ; string address in INVOKE format
    ; --------------------------------
      SADD MACRO quoted_text:VARARG
        EXITM <ADDR literal(quoted_text)>
      ENDM

;#########################################################################

.const

IDD_DLG1						equ 1000
IDC_GRP1						equ 1001
IDC_BTN1						equ 1002
IDC_STC1						equ 1003
IDC_EDT1						equ 1004
IDC_EDT2						equ 1005

.data

RichEditDLL						db 'riched20.dll',0
ciphertext						db 'hc3x):nu',0


.data?
MD_CTX							dd 23 dup (?)
_name							db 56 dup (?)
_nlen							dd ?
_serial							db 17 dup (?)
md								db 16 dup (?)
internal_key					dd 4 dup(?)
hRichEdDLL						dd ?
hInstance						dd ?
CommandLine						dd ?
iccex							INITCOMMONCONTROLSEX <?>

;#########################################################################

.code

start:

	invoke GetModuleHandle,NULL
	mov		hInstance,eax
	invoke GetCommandLine
	mov		CommandLine,eax
	invoke InitCommonControls
	mov		iccex.dwSize,sizeof INITCOMMONCONTROLSEX    ;prepare common control structure
	mov		iccex.dwICC,ICC_DATE_CLASSES
	invoke InitCommonControlsEx,addr iccex
	invoke LoadLibrary,addr RichEditDLL
	mov		hRichEdDLL,eax
	;Show dialogbox
	invoke DialogBoxParam,hInstance,IDD_DLG1,NULL,
		   addr WndProc,NULL
	push	eax
	invoke FreeLibrary,hRichEdDLL
	pop		eax
	invoke ExitProcess,0

;########################################################################

WndProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL strg[9]:DWORD
	
	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		invoke SendDlgItemMessageA,hWin,IDC_EDT1,WM_SETTEXT,0,SADD ("Name..")
		invoke SendDlgItemMessageA,hWin,IDC_EDT2,WM_SETTEXT,0,SADD ("Your serial..")
	.elseif eax==WM_COMMAND
		mov		eax,wParam
		mov		edx,eax
		shr		edx,16
		and		eax,0FFFFh
		.if edx==BN_CLICKED
			.if eax==IDC_BTN1
				pushad
				invoke GetDlgItemText,hWin,IDC_EDT1,addr _name,55
				.if eax>3
					mov _nlen,eax
					lea ebx,offset MD_CTX
					push ebx				
					call MD_Init
					add esp,4
					push _nlen
					push offset _name
					push ebx
					call MD_Hash
					add esp,3*4
					lea  esi,offset md
					push ebx
					push esi			
					call MD_Final
					add esp,2*4
					lea esi,strg					
					invoke lstrcpy,esi,addr ciphertext
					lea edi,offset md
					invoke TEA_encode,esi,edi
					invoke wsprintf,addr _serial,SADD ("%.8lX%.8lX"),dword ptr [esi],dword ptr [esi+4]
					invoke SendDlgItemMessageA,hWin,IDC_EDT2,WM_SETTEXT,0,addr _serial
				.else
					invoke SendDlgItemMessageA,hWin,IDC_EDT2,WM_SETTEXT,0,SADD ("Invalid name len..")
				.endif
				popad	
			.endif
		.endif
	.elseif eax==WM_CLOSE
		invoke EndDialog,hWin,0
	.else
		mov		eax,FALSE
		ret
	.endif
	mov		eax,TRUE
	ret

WndProc endp
MD_Init		proc near		; CODE XREF: DialogFunc+11Ap

arg_0		= dword	ptr  4

		mov	edx, [esp+arg_0]
		push	edi
		mov	ecx, 17h
		xor	eax, eax
		mov	edi, edx
		rep stosd
		mov	dword ptr [edx], 67452301h
		mov	dword ptr [edx+4], 0EFCDAB89h
		mov	dword ptr [edx+8], 89ABCDEFh
		mov	dword ptr [edx+0Ch], 10325476h
		mov	[edx+14h], eax
		mov	[edx+10h], eax
		pop	edi
		retn
MD_Init		endp

MD_Hash		proc near		; CODE XREF: DialogFunc+12Bp

arg_0		= dword	ptr  4
arg_4		= dword	ptr  8
arg_8		= dword	ptr  0Ch

		mov	ecx, [esp+arg_8]
		push	ebx
		mov	ebx, [esp+4+arg_0]
		push	ebp
		push	esi
		push	edi
		mov	eax, [ebx+10h]
		lea	edx, [eax+ecx*8]
		cmp	edx, eax
		mov	[ebx+10h], edx
		jnb	short loc_4019FC
		inc	dword ptr [ebx+14h]

loc_4019FC:				; CODE XREF: MD_Hash+17j
		mov	edi, [ebx+14h]
		mov	edx, ecx
		sar	edx, 1Dh
		shr	eax, 3
		add	edi, edx
		and	eax, 3Fh
		mov	[ebx+14h], edi
		jz	short loc_401A6E
		mov	ebp, 40h
		lea	edi, [eax+ebx+18h]
		sub	ebp, eax
		cmp	ecx, ebp
		jge	short loc_401A37
		mov	esi, [esp+10h+arg_4]
		mov	eax, ecx
		shr	ecx, 2
		rep movsd
		mov	ecx, eax
		and	ecx, 3
		rep movsb
		pop	edi
		pop	esi
		pop	ebp
		pop	ebx
		retn
; 

loc_401A37:				; CODE XREF: MD_Hash+3Ej
		mov	esi, [esp+10h+arg_4]
		mov	ecx, ebp
		mov	edx, ecx
		lea	eax, [ebx+18h]
		shr	ecx, 2
		rep movsd
		mov	ecx, edx
		push	eax
		and	ecx, 3
		push	ebx
		rep movsb
		call	sub_401310
		mov	ecx, [esp+18h+arg_4]
		mov	eax, [esp+18h+arg_8]
		add	esp, 8
		add	ecx, ebp
		sub	eax, ebp
		mov	[esp+10h+arg_4], ecx
		mov	[esp+10h+arg_8], eax
		mov	ecx, eax

loc_401A6E:				; CODE XREF: MD_Hash+2Fj
		cmp	ecx, 40h
		jl	short loc_401AB1
		mov	ebp, ecx
		shr	ebp, 6
		mov	edx, ebp
		neg	edx
		shl	edx, 6
		add	ecx, edx
		mov	[esp+10h+arg_8], ecx

loc_401A85:				; CODE XREF: MD_Hash+CBj
		mov	esi, [esp+10h+arg_4]
		lea	eax, [ebx+18h]
		mov	ecx, 10h
		mov	edi, eax
		push	eax
		push	ebx
		rep movsd
		call	sub_401310
		mov	ecx, [esp+18h+arg_4]
		add	esp, 8
		add	ecx, 40h
		dec	ebp
		mov	[esp+10h+arg_4], ecx
		jnz	short loc_401A85
		mov	ecx, [esp+10h+arg_8]

loc_401AB1:				; CODE XREF: MD_Hash+91j
		mov	esi, [esp+10h+arg_4]
		mov	eax, ecx
		lea	edi, [ebx+18h]
		shr	ecx, 2
		rep movsd
		mov	ecx, eax
		and	ecx, 3
		rep movsb
		pop	edi
		pop	esi
		pop	ebp
		pop	ebx
		retn
MD_Hash		endp


MD_Final	proc near		; CODE XREF: DialogFunc+13Ep

lpString1	= dword	ptr  8
arg_4		= dword	ptr  0Ch

		push	esi
		mov	esi, [esp+arg_4]
		push	edi
		mov	ecx, 3Fh
		mov	eax, [esi+10h]
		sar	eax, 3
		and	eax, 3Fh
		sub	ecx, eax
		lea	edi, [eax+esi+18h]
		mov	byte ptr [edi],	80h
		inc	edi
		cmp	ecx, 8
		jge	short loc_401B1B
		mov	edx, ecx
		xor	eax, eax
		shr	ecx, 2
		rep stosd
		mov	ecx, edx
		and	ecx, 3
		rep stosb
		lea	edi, [esi+18h]
		push	edi
		push	esi
		call	sub_401310
		add	esp, 8
		mov	ecx, 0Eh
		xor	eax, eax
		rep stosd
		jmp	short loc_401B2E
; 

loc_401B1B:				; CODE XREF: MD_Final+21j
		add	ecx, 0FFFFFFF8h
		xor	eax, eax
		mov	edx, ecx
		shr	ecx, 2
		rep stosd
		mov	ecx, edx
		and	ecx, 3
		rep stosb

loc_401B2E:				; CODE XREF: MD_Final+49j
		mov	eax, [esi+10h]
		mov	ecx, [esi+14h]
		lea	edx, [esi+18h]
		mov	[esi+50h], eax
		push	edx
		push	esi
		mov	[esi+54h], ecx
		call	sub_401310
		mov	eax, [esp+0Ch+lpString1]
		add	esp, 8
		mov	byte ptr [esi+58h], 1
		push	esi		; lpString2
		push	eax		; lpString1
		call	ds:lstrcpyA
		pop	edi
		pop	esi
		retn
MD_Final	endp


;#########################################################################]

sub_401310	proc near		; CODE XREF: MD_Hash+70p MD_Hash+B7p
					; MD_Final+38p	MD_Final+6Fp

var_44		= dword	ptr -44h
var_40		= dword	ptr -40h
var_3C		= dword	ptr -3Ch
var_38		= dword	ptr -38h
var_34		= dword	ptr -34h
var_30		= dword	ptr -30h
var_2C		= dword	ptr -2Ch
var_28		= dword	ptr -28h
var_24		= dword	ptr -24h
var_20		= dword	ptr -20h
var_1C		= dword	ptr -1Ch
var_18		= dword	ptr -18h
var_14		= dword	ptr -14h
var_10		= dword	ptr -10h
var_C		= dword	ptr -0Ch
var_8		= dword	ptr -8
arg_0		= dword	ptr  4
arg_4		= dword	ptr  8

		sub	esp, 44h
		mov	eax, [esp+44h+arg_0]
		push	ebx
		push	ebp
		push	esi
		mov	ebx, [eax+4]
		mov	esi, [eax+8]
		mov	edx, [eax+0Ch]
		push	edi
		mov	edi, [eax]
		mov	eax, [esp+54h+arg_4]
		mov	ebp, esi
		mov	ecx, [eax]
		and	ebp, ebx
		mov	[esp+54h+var_44], ecx
		mov	ecx, ebx
		not	ecx
		and	ecx, edx
		or	ecx, ebp
		mov	ebp, [esp+54h+var_44]
		add	ecx, ebp
		mov	ebp, ebx
		add	ecx, edi
		mov	edi, ecx
		shr	edi, 1Dh
		shl	ecx, 3
		or	edi, ecx
		mov	ecx, [eax+4]
		mov	[esp+54h+var_34], ecx
		mov	ecx, edi
		not	ecx
		and	ecx, esi
		and	ebp, edi
		or	ecx, ebp
		mov	ebp, [esp+54h+var_34]
		add	ecx, ebp
		add	edx, ecx
		mov	ecx, edx
		shr	ecx, 19h
		shl	edx, 7
		or	ecx, edx
		mov	edx, [eax+8]
		mov	[esp+54h+var_38], edx
		mov	edx, ecx
		not	edx
		mov	ebp, ecx
		and	edx, ebx
		and	ebp, edi
		or	edx, ebp
		mov	ebp, [esp+54h+var_38]
		add	edx, ebp
		mov	ebp, ecx
		add	esi, edx
		mov	edx, esi
		shr	edx, 15h
		shl	esi, 0Bh
		or	edx, esi
		mov	esi, [eax+0Ch]
		mov	[esp+54h+var_30], esi
		mov	esi, edx
		not	esi
		and	esi, edi
		and	ebp, edx
		or	esi, ebp
		mov	ebp, [esp+54h+var_30]
		add	esi, ebp
		add	ebx, esi
		mov	esi, ebx
		shl	esi, 13h
		shr	ebx, 0Dh
		or	esi, ebx
		mov	ebx, edx
		mov	ebp, esi
		and	ebx, esi
		not	ebp
		and	ebp, ecx
		or	ebp, ebx
		mov	ebx, [eax+10h]
		add	ebp, ebx
		mov	[esp+54h+var_24], ebx
		add	edi, ebp
		mov	ebx, edi
		shr	ebx, 1Dh
		shl	edi, 3
		or	ebx, edi
		mov	edi, [eax+14h]
		mov	[esp+54h+arg_4], ebx
		mov	ebp, esi
		and	ebp, [esp+54h+arg_4]
		mov	[esp+54h+var_10], edi
		not	ebx
		and	ebx, edx
		or	ebx, ebp
		add	ebx, edi
		add	ecx, ebx
		mov	edi, ecx
		shr	edi, 19h
		shl	ecx, 7
		or	edi, ecx
		mov	ecx, [eax+18h]
		mov	ebx, edi
		mov	ebp, edi
		and	ebp, [esp+54h+arg_4]
		mov	[esp+54h+var_1C], ecx
		not	ebx
		and	ebx, esi
		or	ebx, ebp
		mov	ebp, edi
		add	ebx, ecx
		add	edx, ebx
		mov	ebx, [esp+54h+arg_4]
		mov	ecx, edx
		shr	ecx, 15h
		shl	edx, 0Bh
		or	ecx, edx
		mov	edx, [eax+1Ch]
		mov	[esp+54h+var_28], edx
		mov	edx, ecx
		not	edx
		and	edx, ebx
		and	ebp, ecx
		or	edx, ebp
		mov	ebp, [esp+54h+var_28]
		add	edx, ebp
		mov	ebp, ecx
		add	esi, edx
		mov	edx, esi
		shl	edx, 13h
		shr	esi, 0Dh
		or	edx, esi
		mov	esi, [eax+20h]
		mov	[esp+54h+var_40], esi
		mov	esi, edx
		not	esi
		and	esi, edi
		and	ebp, edx
		or	esi, ebp
		mov	ebp, [esp+54h+var_40]
		add	esi, ebp
		mov	ebp, edx
		add	ebx, esi
		mov	esi, ebx
		shr	esi, 1Dh
		shl	ebx, 3
		or	esi, ebx
		mov	ebx, [eax+24h]
		mov	[esp+54h+arg_4], esi
		mov	[esp+54h+var_14], ebx
		and	ebp, [esp+54h+arg_4]
		not	esi
		and	esi, ecx
		or	esi, ebp
		add	esi, ebx
		add	edi, esi
		mov	esi, edi
		shr	esi, 19h
		shl	edi, 7
		or	esi, edi
		mov	edi, [eax+28h]
		mov	ebx, esi
		mov	[esp+54h+var_20], edi
		not	ebx
		and	ebx, edx
		mov	ebp, esi
		and	ebp, [esp+54h+arg_4]
		or	ebx, ebp
		mov	ebp, esi
		add	ebx, edi
		add	ecx, ebx
		mov	ebx, [esp+54h+arg_4]
		mov	edi, ecx
		shr	edi, 15h
		shl	ecx, 0Bh
		or	edi, ecx
		mov	ecx, [eax+2Ch]
		mov	[esp+54h+var_2C], ecx
		mov	ecx, edi
		not	ecx
		and	ecx, ebx
		and	ebp, edi
		or	ecx, ebp
		mov	ebp, [esp+54h+var_2C]
		add	ecx, ebp
		mov	ebp, edi
		add	edx, ecx
		mov	ecx, edx
		shl	ecx, 13h
		shr	edx, 0Dh
		or	ecx, edx
		mov	edx, [eax+30h]
		mov	[esp+54h+var_3C], edx
		mov	edx, ecx
		not	edx
		and	edx, esi
		and	ebp, ecx
		or	edx, ebp
		mov	ebp, [esp+54h+var_3C]
		add	edx, ebp
		mov	ebp, ecx
		add	ebx, edx
		mov	edx, ebx
		shr	edx, 1Dh
		shl	ebx, 3
		or	edx, ebx
		mov	ebx, [eax+34h]
		mov	[esp+54h+arg_4], edx
		mov	[esp+54h+var_C], ebx
		and	ebp, [esp+54h+arg_4]
		not	edx
		and	edx, edi
		or	edx, ebp
		add	edx, ebx
		add	esi, edx
		mov	edx, [eax+38h]
		mov	ebx, esi
		mov	[esp+54h+var_18], edx
		shr	ebx, 19h
		shl	esi, 7
		or	ebx, esi
		mov	eax, [eax+3Ch]
		mov	esi, ebx
		mov	ebp, ebx
		and	ebp, [esp+54h+arg_4]
		mov	[esp+54h+var_8], eax
		not	esi
		and	esi, ecx
		or	esi, ebp
		mov	ebp, ebx
		add	esi, edx
		add	edi, esi
		mov	edx, edi
		shr	edx, 15h
		shl	edi, 0Bh
		or	edx, edi
		mov	edi, [esp+54h+arg_4]
		mov	esi, edx
		and	ebp, edx
		not	esi
		and	esi, edi
		or	esi, ebp
		add	esi, eax
		add	ecx, esi
		mov	esi, ecx
		shl	esi, 13h
		shr	ecx, 0Dh
		or	esi, ecx
		mov	eax, edx
		or	eax, esi
		mov	ecx, edx
		and	eax, ebx
		and	ecx, esi
		or	eax, ecx
		mov	ecx, [esp+54h+var_44]
		add	eax, ecx
		mov	ecx, esi
		lea	eax, [edi+eax+5A827999h]
		mov	edi, eax
		shr	edi, 1Dh
		shl	eax, 3
		or	edi, eax
		mov	eax, esi
		or	ecx, edi
		and	eax, edi
		mov	ebp, ecx
		mov	[esp+54h+arg_4], eax
		and	ebp, edx
		or	ebp, eax
		mov	eax, [esp+54h+var_24]
		add	ebp, eax
		lea	ebx, [ebx+ebp+5A827999h]
		mov	ebp, [esp+54h+var_40]
		mov	eax, ebx
		shr	eax, 1Bh
		shl	ebx, 5
		or	eax, ebx
		mov	ebx, [esp+54h+arg_4]
		and	ecx, eax
		or	ecx, ebx
		add	ecx, ebp
		mov	ebp, [esp+54h+var_3C]
		lea	edx, [edx+ecx+5A827999h]
		mov	ecx, edx
		shr	ecx, 17h
		shl	edx, 9
		or	ecx, edx
		mov	edx, ecx
		mov	ebx, ecx
		or	edx, edi
		and	ebx, edi
		and	edx, eax
		or	edx, ebx
		mov	ebx, ecx
		add	edx, ebp
		mov	ebp, [esp+54h+var_34]
		lea	esi, [esi+edx+5A827999h]
		mov	edx, esi
		shr	edx, 13h
		shl	esi, 0Dh
		or	edx, esi
		mov	esi, ecx
		or	esi, edx
		and	ebx, edx
		and	esi, eax
		or	esi, ebx
		mov	ebx, edx
		add	esi, ebp
		lea	edi, [edi+esi+5A827999h]
		mov	esi, edi
		shr	esi, 1Dh
		shl	edi, 3
		or	esi, edi
		mov	edi, edx
		or	edi, esi
		and	ebx, esi
		mov	ebp, edi
		mov	[esp+54h+arg_4], ebx
		and	ebp, ecx
		or	ebp, ebx
		mov	ebx, [esp+54h+var_10]
		add	ebp, ebx
		lea	eax, [eax+ebp+5A827999h]
		mov	ebx, eax
		shr	ebx, 1Bh
		shl	eax, 5
		or	ebx, eax
		mov	eax, [esp+54h+arg_4]
		mov	ebp, [esp+54h+var_14]
		and	edi, ebx
		or	edi, eax
		add	edi, ebp
		mov	ebp, [esp+54h+var_C]
		lea	edi, [ecx+edi+5A827999h]
		mov	ecx, edi
		shr	ecx, 17h
		shl	edi, 9
		or	ecx, edi
		mov	eax, ecx
		mov	edi, ecx
		or	eax, esi
		and	edi, esi
		and	eax, ebx
		or	eax, edi
		mov	edi, ecx
		add	eax, ebp
		mov	ebp, [esp+54h+var_38]
		lea	eax, [edx+eax+5A827999h]
		mov	edx, eax
		shr	edx, 13h
		shl	eax, 0Dh
		or	edx, eax
		mov	eax, ecx
		or	eax, edx
		and	edi, edx
		and	eax, ebx
		or	eax, edi
		mov	edi, edx
		add	eax, ebp
		lea	eax, [esi+eax+5A827999h]
		mov	esi, eax
		shr	esi, 1Dh
		shl	eax, 3
		or	esi, eax
		mov	eax, edx
		or	eax, esi
		and	edi, esi
		mov	ebp, eax
		mov	[esp+54h+arg_4], edi
		and	ebp, ecx
		or	ebp, edi
		mov	edi, [esp+54h+var_1C]
		add	ebp, edi
		lea	ebx, [ebx+ebp+5A827999h]
		mov	ebp, [esp+54h+var_20]
		mov	edi, ebx
		shr	edi, 1Bh
		shl	ebx, 5
		or	edi, ebx
		mov	ebx, [esp+54h+arg_4]
		and	eax, edi
		or	eax, ebx
		add	eax, ebp
		mov	ebp, [esp+54h+var_18]
		lea	eax, [ecx+eax+5A827999h]
		mov	ecx, eax
		shr	ecx, 17h
		shl	eax, 9
		or	ecx, eax
		mov	eax, ecx
		mov	ebx, ecx
		or	eax, esi
		and	ebx, esi
		and	eax, edi
		or	eax, ebx
		mov	ebx, ecx
		add	eax, ebp
		mov	ebp, [esp+54h+var_30]
		lea	eax, [edx+eax+5A827999h]
		mov	edx, eax
		shr	edx, 13h
		shl	eax, 0Dh
		or	edx, eax
		mov	eax, ecx
		or	eax, edx
		and	ebx, edx
		and	eax, edi
		or	eax, ebx
		add	eax, ebp
		mov	ebx, edx
		lea	eax, [esi+eax+5A827999h]
		mov	esi, eax
		shr	esi, 1Dh
		shl	eax, 3
		or	esi, eax
		mov	eax, edx
		or	eax, esi
		and	ebx, esi
		mov	ebp, eax
		mov	[esp+54h+arg_4], ebx
		and	ebp, ecx
		or	ebp, ebx
		mov	ebx, ebp
		mov	ebp, [esp+54h+var_28]
		add	ebx, ebp
		lea	edi, [edi+ebx+5A827999h]
		mov	ebx, edi
		shr	ebx, 1Bh
		shl	edi, 5
		or	ebx, edi
		mov	edi, [esp+54h+arg_4]
		and	eax, ebx
		or	eax, edi
		mov	edi, [esp+54h+var_2C]
		add	eax, edi
		lea	ecx, [ecx+eax+5A827999h]
		mov	edi, ecx
		shr	edi, 17h
		shl	ecx, 9
		or	edi, ecx
		mov	ecx, edi
		mov	eax, edi
		or	ecx, esi
		and	eax, esi
		and	ecx, ebx
		or	ecx, eax
		mov	eax, [esp+54h+var_8]
		add	ecx, eax
		lea	edx, [edx+ecx+5A827999h]
		mov	ecx, ebx
		mov	eax, edx
		xor	ecx, edi
		shr	eax, 13h
		shl	edx, 0Dh
		or	eax, edx
		mov	edx, [esp+54h+var_44]
		xor	ecx, eax
		add	ecx, edx
		lea	esi, [esi+ecx+6ED9EBA1h]
		mov	ecx, esi
		shr	ecx, 1Dh
		lea	edx, ds:0[esi*8]
		mov	esi, [esp+54h+var_40]
		or	ecx, edx
		mov	edx, edi
		xor	edx, eax
		xor	edx, ecx
		add	edx, esi
		lea	ebx, [ebx+edx+6ED9EBA1h]
		mov	edx, ebx
		shr	edx, 17h
		shl	ebx, 9
		or	edx, ebx
		mov	ebx, [esp+54h+var_24]
		mov	esi, edx
		xor	esi, eax
		xor	esi, ecx
		add	esi, ebx
		lea	edi, [edi+esi+6ED9EBA1h]
		mov	esi, edi
		shr	esi, 15h
		shl	edi, 0Bh
		or	esi, edi
		mov	edi, edx
		xor	edi, esi
		mov	ebx, edi
		xor	ebx, ecx
		add	ebx, [esp+54h+var_3C]
		lea	ebx, [eax+ebx+6ED9EBA1h]
		mov	eax, ebx
		shr	eax, 11h
		shl	ebx, 0Fh
		or	eax, ebx
		mov	ebx, [esp+54h+var_38]
		xor	edi, eax
		add	edi, ebx
		mov	ebx, [esp+54h+var_20]
		lea	edi, [ecx+edi+6ED9EBA1h]
		mov	ecx, edi
		shl	edi, 3
		shr	ecx, 1Dh
		or	ecx, edi
		mov	edi, esi
		xor	edi, eax
		xor	edi, ecx
		add	edi, ebx
		mov	ebx, [esp+54h+var_1C]
		lea	edi, [edx+edi+6ED9EBA1h]
		mov	edx, edi
		shr	edx, 17h
		shl	edi, 9
		or	edx, edi
		mov	edi, edx
		xor	edi, eax
		xor	edi, ecx
		add	edi, ebx
		lea	edi, [esi+edi+6ED9EBA1h]
		mov	esi, edi
		shr	esi, 15h
		shl	edi, 0Bh
		or	esi, edi
		mov	edi, edx
		xor	edi, esi
		mov	ebx, edi
		xor	ebx, ecx
		add	ebx, [esp+54h+var_18]
		lea	ebx, [eax+ebx+6ED9EBA1h]
		mov	eax, ebx
		shr	eax, 11h
		shl	ebx, 0Fh
		or	eax, ebx
		mov	ebx, [esp+54h+var_34]
		xor	edi, eax
		add	edi, ebx
		mov	ebx, [esp+54h+var_14]
		lea	edi, [ecx+edi+6ED9EBA1h]
		mov	ecx, edi
		shr	ecx, 1Dh
		shl	edi, 3
		or	ecx, edi
		mov	edi, esi
		xor	edi, eax
		xor	edi, ecx
		add	edi, ebx
		mov	ebx, [esp+54h+var_10]
		lea	edi, [edx+edi+6ED9EBA1h]
		mov	edx, edi
		shr	edx, 17h
		shl	edi, 9
		or	edx, edi
		mov	edi, edx
		xor	edi, eax
		xor	edi, ecx
		add	edi, ebx
		lea	edi, [esi+edi+6ED9EBA1h]
		mov	esi, edi
		shr	esi, 15h
		shl	edi, 0Bh
		or	esi, edi
		mov	edi, edx
		xor	edi, esi
		mov	ebx, edi
		xor	ebx, ecx
		add	ebx, [esp+54h+var_C]
		lea	ebx, [eax+ebx+6ED9EBA1h]
		mov	eax, ebx
		shr	eax, 11h
		shl	ebx, 0Fh
		or	eax, ebx
		mov	ebx, [esp+54h+var_30]
		xor	edi, eax
		add	edi, ebx
		mov	ebx, [esp+54h+var_2C]
		lea	edi, [ecx+edi+6ED9EBA1h]
		mov	ecx, edi
		shr	ecx, 1Dh
		shl	edi, 3
		or	ecx, edi
		mov	edi, esi
		xor	edi, eax
		xor	edi, ecx
		add	edi, ebx
		lea	edi, [edx+edi+6ED9EBA1h]
		mov	edx, edi
		shr	edx, 17h
		shl	edi, 9
		or	edx, edi
		mov	edi, edx
		xor	edi, eax
		xor	edi, ecx
		add	edi, ebp
		mov	ebp, [esp+54h+var_8]
		lea	edi, [esi+edi+6ED9EBA1h]
		mov	esi, edi
		shr	esi, 15h
		shl	edi, 0Bh
		or	esi, edi
		mov	edi, edx
		xor	edi, esi
		xor	edi, ecx
		add	edi, ebp
		lea	edi, [eax+edi+6ED9EBA1h]
		mov	eax, [esp+54h+arg_0]
		mov	ebx, [eax]
		add	ebx, ecx
		mov	ecx, edi
		shr	ecx, 11h
		shl	edi, 0Fh
		or	ecx, edi
		mov	edi, [eax+4]
		add	ecx, edi
		pop	edi
		mov	[eax+4], ecx
		mov	ecx, [eax+8]
		add	ecx, esi
		pop	esi
		mov	[eax+8], ecx
		mov	ecx, [eax+0Ch]
		add	ecx, edx
		mov	[eax], ebx
		pop	ebp
		mov	[eax+0Ch], ecx
		pop	ebx
		add	esp, 44h
		retn
sub_401310	endp

TEA_encode	PROC	ptrData:DWORD, ptrKey:DWORD
	pushad

	mov	esi, ptrKey	
	mov	eax, dword ptr [esi]
	mov	ebx, dword ptr [esi+4]
	mov	ecx, dword ptr [esi+8]
	mov	edx, dword ptr [esi+12]	
	mov	dword ptr [internal_key], eax
	mov	dword ptr [internal_key+4], ebx
	mov	dword ptr [internal_key+8], ecx
	mov	dword ptr [internal_key+12], edx

	push	ebp
	mov	ebx, ptrData
	xor	edx, edx			;suma
	mov	esi, dword ptr [ebx]
	mov	edi, dword ptr [ebx+4]
	mov	ebp, 32

_loop:
	add	edx, 9E3779B9h			;sum += DELTA;

	mov	eax, edi
	mov	ecx, eax
	mov	ebx, edi
	shl	eax, 4
	shr	ebx, 5
	add	eax, dword ptr [internal_key+ 0*4]
	add	ebx, dword ptr [internal_key+ 1*4]
	add	ecx, edx
	xor	ecx, eax
	xor	ecx, ebx

	add	esi, ecx			;esi = y	;y += (z << 4)+a ^ z+sum ^ (z >> 5)+b;

	mov	eax, esi
	mov	ebx, esi
	mov	ecx, esi

	shl	eax, 4
	shr	ebx, 5
	add	eax, dword ptr [internal_key+ 2*4]
	add	ebx, dword ptr [internal_key+ 3*4]
	add	ecx, edx
	xor	ecx, eax
	xor	ecx, ebx

	add	edi, ecx			;edi = z	;z += (y << 4)+c ^ y+sum ^ (y >> 5)+d;

	dec	ebp
	jnz	_loop

	mov	dword ptr [internal_key], ebp
	mov	dword ptr [internal_key+4], ebp
	mov	dword ptr [internal_key+8], ebp
	mov	dword ptr [internal_key+12], ebp
	
	pop	ebp
	mov	ebx, ptrData
	mov	dword ptr [ebx], esi
	mov	dword ptr [ebx+4], edi
	popad
	ret
TEA_encode	ENDP


end start

